config/routes.rb
Rails.application.routes.draw do

    resources :guidelines
    get '/search' => 'guidelines#search'
    root 'guidelines#index'
    post '/new_doc' => 'guidelines#new_document'
    post '/new_child' => 'guidelines#new_child'
    post '/publish' => 'guidelines#publish'
    post '/pub_all' => 'guidelines#publish_all'
    get '/api' => 'guidelines#api'
    get 'guidelines/preview/:id' => 'guidelines#preview'
    get 'guidelines/full/:id' => 'guidelines#full'
    post '/serialize' => 'guidelines#serialize'
end

app/models/guideline.rb
class Guideline < ActiveRecord::Base
    include PgSearch
    include Filterrific

    #Defining Parent/Child Relationships
    has_many :children, class_name: "Guideline", foreign_key: "parent_id", primary_key: "id"
    belongs_to :parent, class_name: "Guideline", primary_key: "id", foreign_key: "parent_id"


    #API scopes
    #This are the deinfed scopes as per code-review
    scope :published, -> { where(published: true) }
    scope :note_date, -> (date) {
      where("? >= start_date
      AND (end_date IS NULL
      OR end_date > ?)", date, date)}
    scope :investor, -> (investor) {where(investor: investor)}
    scope :program, -> (program) {where(program: program)}
    scope :client, -> (client){where(client: client)}




    #PGSearch Scopes
    multisearchable :against => [:investor]

    pg_search_scope :search, against: [:investor, :body, :title],
                                using: {tsearch: {dictionary: "english"}}
    pg_search_scope :titlesearch, against: [:title],
                                using: {tsearch: {:prefix => true}}
    pg_search_scope :bodysearch, against: [:body],
                                using: {tsearch: {:prefix => true}}

    #Create Filter Instance with prototypes of options
    filterrific :default_settings => {:is_document => 0,
                                    :pub_status => 0,
                                    :sorted_by => 'recent_desc',
                                    :with_date => Date.today()},
                :filter_names => %w[
                  with_date
                  with_investor
                  with_program
                  with_client
                  with_title
                  with_body
                  is_document
                  pub_status
                  sorted_by
                ]


  #Filteriffic Scopes
  scope :with_title, lambda { |query|
    #Filter by Title
    terms = query.downcase.split(/\s+/)

    titlesearch(terms)
  }
  scope :with_body, lambda { |query|
    #Filter by Body content
    terms = query.downcase.split(/\s+/)

    bodysearch(terms)
  }
  scope :with_investor, lambda { |investor|
    #Filters Guide list by investors

    investor = "%" + investor.downcase + "%"

    where('LOWER(guidelines.investor) LIKE ?', investor)
  }
  scope :with_client, lambda { |client|
    #Filters Guide list by client

    client = "%" + client.downcase + "%"

    where('LOWER(guidelines.client) LIKE ?', client)
  }
  scope :with_program, lambda { |program|
    #Filters Guide list by program

    program = "%" + program.to_s.downcase + "%"

    where('LOWER(guidelines.program) LIKE ?', program)
  }
  scope :with_date, lambda { |date|
    #Filter by date range

    where('guidelines.start_date IS NULL OR (guidelines.start_date <= ?
      AND (guidelines.end_date IS NULL
      OR guidelines.end_date >= ?))', date, date)

  }
  scope :is_document, lambda { |bool|
    #Unchecked: false, show only document titles
    #Checked:   true, show all guideline sections
=begin
    if bool == 0
      where('guidelines.parent_id IS NULL')
    end
=end
  }
  scope :pub_status, lambda { |pub_option|
    #Filter out based on the published status options

    if pub_option == 1
      where('guidelines.published IS TRUE')
    elsif pub_option == 2
      where('guidelines.published IS NOT TRUE')
    end
  }
  scope :sorted_by, lambda { |sort_option|
    # extract the sort direction from the param value.
    direction = (sort_option =~ /desc$/) ? 'desc' : 'asc'
    case sort_option.to_s
    when /^created_at_/
      order("guidelines.created_at #{ direction }")
    when /^title_/
      order("LOWER(guidelines.title) #{ direction }")
    when /^recent_/
      order("guidelines.recent_view_at #{ direction }")
    else
      raise(ArgumentError, "Invalid sort option: #{ sort_option.inspect }")
    end
  }

  #Ways for the Controller to access the relationships
  #Used in the API Calls
  def children?
    #IF there are children
    children.any?
  end
  def descendents
    #The call used to get all children
    #and the children of their children etc.
    self.class.tree_for(self)
  end
  def self.tree_for(instance)
    #helper for #descendents
    where("guidelines.id IN (#{Guideline.tree_sql_for(instance)})").order("guidelines.id")
  end
  def self.tree_sql_for(instance)
    #helper for #descendents
    tree_sql =  <<-SQL
      WITH RECURSIVE search_tree(id, path) AS (
          SELECT id, ARRAY[id]
          FROM guidelines
          WHERE id = #{instance.id}
        UNION ALL
          SELECT guidelines.id, path || guidelines.id
          FROM search_tree
          JOIN guidelines ON guidelines.parent_id = search_tree.id
          WHERE NOT guidelines.id = ANY(path)
      )
      SELECT id FROM search_tree ORDER BY path
    SQL
  end


  #Options group for Filterrific 'Order By' Selector
  def self.options_for_sorted_by
    [
      ['Recently Viewed', 'recent_desc'],
      ['Title (A-Z)', 'title_asc'],
      ['Title (Z-A)', 'title_desc'],
      ['Newest First', 'created_at_desc'],
      ['Oldest First', 'created_at_asc']
    ]
  end

  #Options group for Filterrific 'Status' Selector
  def self.options_for_pub_status
    [
      ['All Documents', 0],
      ['Only Published', 1],
      ['Only Unpublished', 2]
    ]
  end
end

app/controllers/guidelines_controller.rb
class GuidelinesController < ApplicationController

    #Index controller, get filterrific working
    def index
      #Instantiate Filterific, and respond to the forms
      @filterrific = Filterrific.new(
        Guideline, params[:filterrific]
      ) or return

      @guidelines = Guideline.filterrific_find(@filterrific)

      if params[:filterrific]
        if params[:filterrific][:is_document] == 0
          @docs = true
        else
          @docs = false
        end
      else
        @docs = true
      end

      respond_to do |format|
        format.html
        format.js
        format.json {api(params)}
      end
    end

    #Controller for the API endpoints called
    #by the underwriter's program
    #all of the ones that could be changed to scopes have been changed
    def api(params)
      @guideline = Guideline.published.note_date(params[:note_date])
      @guideline = @guideline.client(params[:client]) if params[:client]
      @guideline = @guideline.investor(params[:investor]) if params[:investor]
      @guideline = @guideline.program(params[:program]) if params[:program]
      @guideline = fullSearch(params[:search_text], params[:ids]) if params[:search_text]

      #Theses are not really used they are left in case you want to use them.
      @guideline = findChildren(params[:parent]) if params[:parent]
      @guideline = findParent(params[:child]) if params[:child]
      @guideline = findAllChildren(params[:allchilds]) if params[:allchilds]

      render json: @guideline
    end

    #Controller for the OLD search page
    def search
    end

    #Defining Guideline Creation
    def new
      @guideline = Guideline.new
    end
    def create
      @guideline = Guideline.new(guideline_params)

      @guideline.save

      redirect_to @guideline
    end

    #Edit, bring up the given Guide by ID
    def edit
      @guideline = Guideline.find(params[:id])
      @guideline.update_attribute(:recent_view_at, DateTime.current())
    end

    def big_edit
      @guideline = Guideline.find(params[:id])
      render 'big_edit'
    end

    #Show, bring up the given Guide by ID
    def show
      if params[:date] && params[:date] != ""
        @version_date = Date.parse(params[:date])
      else
        @version_date = Date.today()
      end
      @guideline = Guideline.find(params[:id])
      @guideline.update_attribute(:recent_view_at, DateTime.current())
      respond_to do |format|
        format.html
        format.json { render json: @guideline }
      end
    end

    #Delete a guide and all its descendents,
    #then redirect back to the correct page.
    def destroy

      @guideline = Guideline.find(params[:id])
      g = @guideline.parent_id  #store parent id to redirect to correct place when done with deletion
      gu = @guideline.descendents
      gu.each do |guide|
        Guideline.destroy(guide.id)
      end
      #Guideline.destroy(@guideline.id)
      if g != nil             #this will redirect to the view page of document that the deleted guide was a part of
        g = Guideline.find(g)
        if params[:source] == 'full'
          redirect_to guidelines_path + '/full/' + g.id.to_s
        else
          redirect_to :back
        end
      else #this redirects to that root page if what was deleted was a top-level document
        redirect_to guidelines_path
      end
    end

    #Update, handles normal single guide updates, and also the
    #'save to children' and 'override' funtionality is here.
    def update
      @guideline = Guideline.find(params[:id])
      if params[:commit] == 'Save To Children' #checks to see which type of save to do
        g = @guideline.descendents
        #check to see what check boxes are marked and apply the selected fields to all children

        if params[:start_check]
          g.each do |guide|
            @guideline.update(start_date: params[:guideline][:start_date])
            guide.start_date = @guideline.start_date
          end
        end
        if params[:end_check]
          g.each do |guide|
            @guideline.update(end_date: params[:guideline][:end_date])
            guide.end_date = @guideline.end_date
          end
        end
        if params[:program_check]
          g.each do |guide|
            @guideline.update(program: params[:guideline][:program])
            guide.program = @guideline.program
          end
        end
        if params[:investor_check]
          g.each do |guide|
            @guideline.update(investor: params[:guideline][:investor])
            guide.investor = @guideline.investor
          end
        end
        if params[:client_check]
          g.each do |guide|
            @guideline.update(client: params[:guideline][:client])
            guide.client = @guideline.client
          end
        end
        g.each do |guide|
          guide.save
        end
        redirect_to :back
      else
        if @guideline.update(guideline_params)
            redirect_to :back
        else
            render 'edit'
        end
      end
    end

    #Document Preview
    def preview
      @guideline = Guideline.find(params[:id])
      if params[:date] && params[:date] != ""
        @version_date = Date.parse(params[:date])
      else
        @version_date = Date.today()
      end
    end

    #Full Page Editor
    def full
      @guideline = Guideline.find(params[:id])
      if params[:date] && params[:date] != ""
        @version_date = Date.parse(params[:date])
      else
        @version_date = Date.today()
      end
    end

    #API Call Functions
    def findChildren(parent)
      #Returns all children
        @guideline = @guideline.find(parent)
        @guideline = @guideline.children
    end
    def findParent(child)
      #Returns the immediate parent
        @guideline = @guideline.where("id = ?", child)
        @guideline = @guideline.first.parent
    end
    def findAllChildren(parent)
      #returns all children and their children's children etc
        @guideline = @guideline.where("id = ?", parent)
        @guideline = @guideline.first.descendents
    end
    def fullSearch(text, ids)
      #returns all guides that have a text match in
      #title or body. Supports partial words and is
      #case insensitive.
        c = ids.split(',').map(&:to_i)
        @guideline = Guideline.search(text).where('id IN (?)', c).published
    end

    #When new docs/children are created, give them
    #some starting data, to not break the db
    def new_document
      if params[:newGuide][:title] == ""
        params[:newGuide][:title] = "New Document"
      end
      Guideline.create(position: '0',
                      start_date: '',
                      end_date: '',
                      client: '',
                      investor: '',
                      program: '',
                      parent_id: nil,
                      title: params[:newGuide][:title],
                      body: '',
                      published: false,
                      recent_view_at: DateTime.current()
                      )
      redirect_to root_path
    end

    ##Children automatically inherit data fields from
    ##their parent, but content fields are left 'blank'
    def new_child
      @parent = Guideline.find(params[:newChild][:parent])
      if @parent.children?
        @siblings = Guideline.where('guidelines.parent_id = ?', params[:newChild][:parent])
        pos = 1
        @siblings.each do |sib|
          if sib.position > pos
            pos = sib.position
          end
        end
        pos += 1
      else
        pos = 1
      end
      Guideline.create(position: pos,
                      start_date: @parent.start_date,
                      end_date: @parent.end_date,
                      client: @parent.client,
                      investor: @parent.investor,
                      program: @parent.program,
                      parent_id: params[:newChild][:parent],
                      title: 'New Child',
                      body: '',
                      published: false,
                      recent_view_at: DateTime.current()
                      )

    redirect_to :back
    end

    #Set a guide to published, redirect to the
    #appropriate page
    def publish
      @guideline = Guideline.find(params[:id])
      if (params[:act] == 'unp')
        @guideline.update_attribute(:published, false)
      else
        @guideline.update_attribute(:published, true)
      end
      redirect_to :back
    end

    #Publish the entire Document, Parent and all
    #descendents recursively.
    def publish_all
      @guideline = Guideline.find(params[:pub])

      if (params[:act] == 'unp')
        action = false
      else
        action = true
        @guideline.update_attribute(:published, action)
      end

      @guidelines = @guideline.descendents
      @guidelines = @guidelines.note_date(params[:date])
      @guidelines.each do |guide|
        guide.update_attribute(:published, action)
      end
      redirect_to :back
    end


    #Set standard options for the serializer
    def default_serializer_options
        {root: false}
    end

    #Serialize drag & drop list
    def serialize
      if(params[:message])
        newOrder = JSON.parse(params[:message])
        #this finds the correct document to put all of the guides under
        p = Guideline.find(newOrder[0]["id"])
        while Guideline.find(p).parent_id != nil
          p = Guideline.find(p).parent_id
        end
        reorder(newOrder, p)
        redirect_to :back
      else
        redirect_to root_path
      end
    end

    def reorder(list, parent)
      if list.respond_to?(:each)
        count = 1
        list.each do |l|
          g = Guideline.find(l["id"])
          g.position = count
          g.parent_id = parent
          g.save
          if (l["children"] != nil)
            reorder(l["children"], l["id"])
          end
          count = count + 1
        end
      else

app/helpers/guidelines_helper.rb
module GuidelinesHelper
end

app/views/guidelines/_form.html.erb
<%= form_for @guideline do |f| %>
<% if @guideline.errors.any? %>
<div id="error_explanation">
  <h2><%= pluralize(@guideline.errors.count, "error") %> prohibited this guideline from being saved:</h2>
  <ul>
    <% @guideline.errors.full_messages.each do |msg| %>
    <li><%= msg %></li>
    <% end %>
  </ul>
</div>
<% end %>
<%= f.hidden_field :id, :value => @guideline.id %>
<div class="panel panel-default">
  <div class="panel-heading">
    <%= f.label "Title" %>
    <%= f.text_field :title , class:"form-control input-lg"%>
  </div>
  <div class="panel-body">
    <div class="row">
      <div class="form-group check-input col-xs-12 col-sm-5 col-md-5 col-lg-5">
        <%= f.label "Start Date" %>
        <div class="input-group">
          <% if @guideline.parent_id == nil %>
          <%= f.text_field :start_date, value: @guideline.start_date, class:"form-control date", disabled: true %>
          <% else %>
            <%= f.text_field :start_date, value: @guideline.start_date, class:"form-control date" %>
          <% end %>
          <span class="input-group-addon">
            <%= check_box_tag 'start_check', type: "checkbox" %>
          </span>
        </div>
      </div>
      <div class="form-group check-input col-xs-12 col-sm-5 col-md-5 col-lg-5">
        <%= f.label "End Date" %> <br>
        <div class="input-group">
          <% if @guideline.parent_id == nil %>
            <%= f.text_field :end_date, value: @guideline.end_date, class:"form-control date", disabled: true %>
          <% else %>
            <%= f.text_field :end_date, value: @guideline.end_date, class:"form-control date" %>
          <% end %>
          <span class="input-group-addon">
            <%= check_box_tag 'end_check', type: "checkbox" %>
          </span>
        </div>
      </div>
      <div class="form-group check-input col-xs-12 col-sm-2 col-md-2 col-lg-2">
        <label>Published Status</label><br>
        <% if @guideline.published %>
          <span class="glyphicon glyphicon-ok-sign text-success" style="font-size: 25px"></span>
        <% else %>
          <span class="glyphicon glyphicon-exclamation-sign text-warning" style="font-size: 25px"></span>
        <% end %>
      </div>
    </div>
      <div class="row">
        <div class="form-group check-input col-xs-12 col-sm-4 col-md-4 col-lg-4">
          <%= f.label :program %><br>
          <div class="input-group">
            <%= f.text_field :program, value: @guideline.program, class:"form-control" %>
            <span class="input-group-addon">
              <%= check_box_tag 'program_check', type: "checkbox" %>
            </span>
          </div>
        </div>
        <div class="form-group check-input col-xs-12 col-sm-4 col-md-4 col-lg-4">
          <%= f.label :investor %><br>
          <div class="input-group">
            <%= f.text_field :investor, value: @guideline.investor, class:"form-control" %>
            <span class="input-group-addon">
              <%= check_box_tag 'investor_check', type: "checkbox" %>
            </span>
          </div>
        </div>
          <div class="form-group check-input col-xs-12 col-sm-4 col-md-4 col-lg-4">
            <%= f.label :client %><br>
            <div class="input-group">
              <%= f.text_field :client, value: @guideline.client, class:"form-control" %>
              <span class="input-group-addon">
                <%= check_box_tag 'client_check', type: "checkbox" %>
              </span>
            </div>
          </div>
        </div>
      </div>
      <div class ="row">
        <div class="form-group check-input col-xs-12 col-sm-12 col-md-12 col-lg-12">
          <%= f.label "Guide content" %>
          <div class="input-group">
            <% if @guideline.parent_id == nil %>
              <%= f.text_area :body, value: @guideline.body, rows:"12", class:"form-control", style:"resize: vertical", disabled: true%>
            <% else %>
              <%= f.text_area :body, value: @guideline.body, rows:"12", class:"form-control", style:"resize: vertical", id: 'editor'%>
            <% end %>
            <span class="input-group-addon"></span>
          </div>
        </div>
      </div>
    <!-- Markdown Preview -->
    <div class="form-group check-input" >
      <%= f.label "Preview" %>&nbsp;&nbsp;<span class="label label-default"></span>
      <div class="well preview">
        <h3><%= @guideline.title %></h3>
        <div style="margin-left: 30px" id="previewField">
        </div>
      </div>

    <!-- End of markdown preview -->
  </div>
  <div class="panel-footer clearfix">
    <span class="">
      <%= f.submit "Save", class: "btn btn-primary btn-sm save", title:"Tooltip test", data: {toggle:"tooltip", placement:"left"} %>
      <!--<button type="button" class="btn btn-warning btn-sm save" data-toggle="modal" data-target=".override-modal">Override</button>-->
      <%= link_to "Publish", publish_path(pub: @guideline.id), method: 'post', class:"btn btn-default btn-sm" %>
      <span class="saved-message">Guideline saved <span class="glyphicon glyphicon-ok"></span></span>
    </span>
    <span class="pull-right">
      <%= f.submit "Save To Children", class: "btn btn-primary btn-sm"  %>
      <!--<button type="button" class="btn btn-primary btn-sm" data-toggle="modal" data-target=".confirm-modal">Save children</button>-->
      <!--<button type="button" class="btn btn-warning btn-sm" data-toggle="modal" data-target=".override-all-modal">Override children</button>-->

      <%= link_to "Delete", guideline_path(@guideline),
      method: :delete, data: {confirm: 'Are you sure you want to delete '+ @guideline.title + ' and all of its children?'},
      class:"btn btn-danger btn-sm" %>
      <!--<button type="button" class="btn btn-danger btn-sm" data-toggle="modal" data-target=".delete-modal">Delete</button>-->
    </span>
  </div>
</div>
<% end %>

app/views/guidelines/_smallForm.html.erb
<%= form_for @guideline do |f| %>

<% if @guideline.errors.any? %>
  <div id="error_explanation">
    <h2><%= pluralize(@guideline.errors.count, "error") %> prohibited
      this guideline from being saved:</h2>
    <ul>
      <% @guideline.errors.full_messages.each do |msg| %>
      <li><%= msg %></li>
      <% end %>
    </ul>
  </div>
<% end %>


<div class="panel-group" id="accordion">
  <div class="panel panel-default">
    <div class="panel-heading accordion-panel collapsed" id="data" data-toggle="collapse" data-parent="#accordion" href="#collapseTwo">
      <span class="accordion-symbol glyphicon glyphicon-chevron-right"></span>
      <h4 class="panel-title">Data</h4>
    </div>
    <div id="collapseTwo" class="panel-collapse collapse">
      <div class="panel-body">
        <div class="form-group check-input">
          <%= f.label "Start Date" %>
          <div class="input-group">
            <% if @guideline.parent_id == nil %>
              <%= f.text_field :start_date, value: @guideline.start_date, class:"form-control date", disabled: true %>
            <% else %>
              <%= f.text_field :start_date, value: @guideline.start_date, class:"form-control date" %>
            <% end %>
            <span class="input-group-addon">
            <%= check_box_tag 'start_check', type: "checkbox" %>
            </span>
          </div>
        </div>
        <div class="form-group check-input">
          <%= f.label "End Date" %> <br>
          <div class="input-group">
            <% if @guideline.parent_id == nil %>
              <%= f.text_field :end_date, value: @guideline.end_date, class:"form-control date", disabled: true %>
            <% else %>
              <%= f.text_field :end_date, value: @guideline.end_date, class:"form-control date" %>
            <% end %>
            <span class="input-group-addon">
              <%= check_box_tag 'end_check', type: "checkbox" %>
            </span>
          </div>
        </div>
        <div class="form-group check-input">
          <%= f.label :program %><br>
          <div class="input-group">
            <%= f.text_field :program, value: @guideline.program, class:"form-control" %>
            <span class="input-group-addon">
              <%= check_box_tag 'program_check', type: "checkbox" %>
            </span>
          </div>
        </div>
        <div class="form-group check-input">
          <%= f.label :investor %><br>
          <div class="input-group">
            <%= f.text_field :investor, value: @guideline.investor, class:"form-control" %>
            <span class="input-group-addon">
              <%= check_box_tag 'investor_check', type: "checkbox" %>
            </span>
          </div>
        </div>
        <div class="form-group check-input">
          <%= f.label :client %><br>
          <div class="input-group">
            <%= f.text_field :client, value: @guideline.client, class:"form-control" %>
            <span class="input-group-addon">
              <%= check_box_tag 'client_check', type: "checkbox" %>
            </span>
          </div>
        </div>
        <div class="form-group check-input">
          <%= f.label :published %><br>
          <div class="input-group">
            <% if @guideline.published %>
              <span class="glyphicon glyphicon-ok-sign text-success" style="font-size: 20px"></span>
            <% else %>
              <span class="glyphicon glyphicon-exclamation-sign text-warning" style="font-size: 20px"></span>
            <% end %>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="panel panel-default">
    <div class="panel-heading accordion-panel" id="content" data-toggle="collapse" data-parent="#accordion" href="#collapseOne">
      <span class="accordion-symbol glyphicon glyphicon-chevron-down"></span>
      <h4 class="panel-title">Content</h4>
    </div>
    <div id="collapseOne" class="panel-collapse collapse in">
      <div class="panel-body">
        <div class="form-group check-input">
          <%= f.label "Title" %>
          <div class="input-group">
            <%= f.text_field :title , class:"form-control input-lg", size:"100"%>
          </div>
        </div>
        <div class="form-group check-input">
          <%= f.label "Body" %>
          <div class="input-group">
            <% if @guideline.parent_id == nil %>
            <%= f.text_area :body, value: @guideline.body, rows:"18", cols:"100", class:"form-control", style:"resize: none", disabled: true, id:"editor"%>
            <% else %>
            <%= f.text_area :body, value: @guideline.body, rows:"18", cols:"100", class:"form-control", style:"resize: none", id:"editor"%>
            <% end %>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<div class="well">
  <span class="">
    <%= f.submit "Save", class: "btn btn-primary btn-sm save" %>
    <button type="button" class="btn btn-danger btn-sm" data-toggle="modal" data-target="#deleteConfirm">Delete</button>
    <%= link_to "Publish", publish_path(id: @guideline.id, act: 'pub'), method: 'post', class:"btn btn-default btn-sm" %>
    <%= link_to "Unpublish", publish_path(id: @guideline.id, act: 'unp'), method: 'post', class:"btn btn-default btn-sm" %>
    <span class="saved-message">Guideline saved <span class="glyphicon glyphicon-ok"></span></span>
  </span>
  <span class="pull-right">
    <% if @guideline.parent_id == nil %>
      <button type="button" class="btn btn-primary btn-sm" data-toggle="modal" data-target="#bigEditModal" disabled='true'>Big Editor</button>
    <% else %>
      <button type="button" class="btn btn-primary btn-sm" data-toggle="modal" data-target="#bigEditModal">Big Editor</button>
    <% end %>
    <button type="button" class="btn btn-primary btn-sm" data-toggle="modal" data-target="#saveChildrenConfirm">Save To Children</button>

  </span>
</div>

<!-- Modals -->

<div class="modal fade" id="saveChildrenConfirm" tabindex="-1" role="dialog" aria-labelledby="saveChildrenConfirm" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
        <h4 class="modal-title" id="myModalLabel">Confirmation</h4>
      </div>
      <div class="modal-body">
        <h3>Are you sure you want to save checked fields to children?</h3>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
        <%= f.submit "Save To Children", class: "btn btn-primary btn-sm"  %>
      </div>
    </div>
  </div>
</div>

<div class="modal fade" id="deleteConfirm" tabindex="-1" role="dialog" aria-labelledby="deleteConfirm" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
        <h4 class="modal-title" id="myModalLabel">Confirmation</h4>
      </div>
      <div class="modal-body">
        <h3>Are you sure you want to delete this guide and its children?</h3>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
        <%= link_to "Delete", guideline_path(:id => @guideline, :source => 'full'), method: :delete, class:"btn btn-danger btn-sm" %>
      </div>
    </div>
  </div>
</div>

<!-- big editor modal-->
<div class="modal fade modal-xl" id="bigEditModal" tabindex="-1" role="dialog" aria-labelledby="saveChildrenConfirm" aria-hidden="true">
  <div class="modal-dialog modal-xl">
    <div class="modal-content modal-xl">
      <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 class="modal-title" id="myModalLabel">Large Editor</h4>
          <%= f.submit "Save", class: "btn btn-primary btn-sm save" %>
      </div>
      <div class="row">
        <div class="col-lg-6 col-md-6 col-sm-6">
          <%= f.text_area :body, value: @guideline.body, rows:"34", cols:"100", class:"form-control linked", id:"modalEditor", style:"resize: none;" %>
        </div>
        <div class="col-lg-6 col-md-6 col-sm-6">
          <div class="form-group check-input" >
            <div class="well" style="padding-top:10px;padding-left: 10px;">
              <!-- Define the are for the live preview -->
              <div style="margin-left: 30px; overflow: auto; height: 650px;" id='modalPreview' class="linked"></div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<% end %>

app/views/guidelines/_tree.erb
<% g = Guideline.where('id = ?', params[:id]) %>
<% t = Time.now.strftime("%m/%d/%Y") %>

<div class="panel panel-default tree">
  <div class="panel-heading clearfix">
    <%= link_to g.first.title, edit_guideline_path(g.first), class:"panel-title pull-left document-shell"%>
    <span class="pull-right">
      <%= form_for :newChild, url: url_for(:controller => :guidelines, :action => :new_child) do |f| %>
      <%= f.hidden_field :parent, value: g.first.id %>
      <%= f.hidden_field :guide, value: 0 %>
      <%= f.submit "New Child", class:"btn btn-sm btn-default" %>
      <% end %>
    </span>
    <span class="pull-right" style="padding-right: 25px">
      <form action="?" method="get">
        Version Date:
        <%= text_field_tag("date", @version_date, class:"date") %>
      </form>
    </span>
  </div>
  <div class="panel-body">
    <div class="dd" id="nestable">
      <%= render partial: 'children', locals: {gid: g.first.id, small: false, selected: nil} %>
    </div>
  </div>
</div>
<textarea id="nestable-output"></textarea>

app/views/guidelines/results.html.erb
<h1>Search Results</h1>

<%= render 'list' %>

<%= link_to 'Back to all guidelines', guidelines_path %>